/****************************************************************************
 *
 *  *********************************************************************
 *  *   Copyright (C) 2002-2005 KONICA MINOLTA MEDICAL&GAPHIC, INC.     *
 *  *   All rights reserved.                                            *
 *  *********************************************************************
 *
 *Υƥ̾Ρ
 *  DRYPRO MODEL 771 PEBǥХɥ饤
 *
 *Υ⥸塼̾Ρ
 *  PrnDev.c
 *
 *Υȡ
 *  ǥХɥ饤ФΥե
 *
 ****************************************************************************/

#if defined(CONFIG_SMP)
  #define __SMP__
#endif

#if defined(CONFIG_MODVERSIONS)
  #define MODVERSIONS
  #include <modversions.h>
#endif

#ifdef MODULE
  #include <linux/module.h>
  MODULE_LICENSE("GPL");
#endif

#include <linux/kernel.h>
#include <linux/errno.h>
#include <linux/mm.h>
#include <linux/string.h>

//Kernel 2.4.17б
//#include <linux/malloc.h>
#include <linux/slab.h>

#include <linux/fs.h>
#include <linux/stddef.h>
#include <linux/version.h>
#include <asm/segment.h>
#include <linux/pci.h>
#include <asm/io.h>
#include <linux/ioport.h>
#include <asm/uaccess.h>
#include <linux/delay.h>
#include <asm/irq.h>

#include "PrnIf.h"
#include "PrnDrv.h"

#define  DRIVER_MAJOR_VERSION     1
#define  DRIVER_MINOR_VERSION     14

#define  PRN_PHYSICAL_2M            //ʪ2Mб̵ξ128KBݤȤʤ

/***** ץȥ *****************************************************/

/* ᥽å */
static int  prn_open( struct inode *inode, struct file *file );
static int  prn_close( struct inode *inode, struct file *file );
static int  prn_ioctl( struct inode *inode, struct file *file, unsigned int function, unsigned long arg);
static int  prn_read( struct file *, char *, size_t, loff_t * );
static int  prn_write( struct file *, char *, size_t, loff_t * );
static int  prn_fasync( int, struct file *, int );

/* IOCTLؿ */
static int  Prn_GetLoadStat( unsigned long arg );
static int  Prn_Close( unsigned long arg );
static int  Prn_ResRead( unsigned long arg );
static int  Prn_CmdWrite( unsigned long arg );
static int  Prn_MemRead( unsigned long arg );
static int  Prn_MemWrite( unsigned long arg );
static int  Prn_DmaWrite( unsigned long arg );
static int  Prn_DmaRead( unsigned long arg );
static int  Prn_GetInterrupt( unsigned long arg );
static int  Prn_CpUsrToKer( unsigned long arg );
static int  Prn_CpKerToUsr( unsigned long arg );
static int  Prn_Config( unsigned long arg );
static int  Prn_RegRead( unsigned long arg );
static int  Prn_RegWrite( unsigned long arg );
static int  Prn_GetSysErr( unsigned long arg );
static int  Prn_PciLar1Set( unsigned long arg );
static int  Prn_GetVersion( unsigned long arg );
static int  Prn_MemRead_cs1( unsigned long arg );
static int  Prn_MemWrite_cs1( unsigned long arg );

/* ؿ */
static void Prn_interrupt( int irq, void *dev_id, struct pt_regs *regs );
void        DumpPciConfig( unsigned char bus, unsigned char fn );
short       PciLar1Set( unsigned long addr );
static int  FpgaCnfWtSeq( size_t size );


/***** ڥ졼ơ֥ ***********************************************/
static struct file_operations prn_fops = {    // Linux 2.4.0 εҤ餷
    read:       prn_read,
    write:      (void *)prn_write,
    ioctl:      prn_ioctl,
    open:       prn_open,
    release:    prn_close,
    fasync:     prn_fasync,
};

/***** ǥХ¤ ***************************************************/
#define PRN_DEV_MAX_NUM     1  //̤ϥǥХĤǹԤ
typedef struct{
    struct fasync_struct  *fasync;  //Ʊѥ塼
} PRN_DEV_STR;

static PRN_DEV_STR  PrnInfo[PRN_DEV_MAX_NUM];
/***** Хѿ *******************************************************/
unsigned long  PioBase;
unsigned long  MemBase1;          //CS2
unsigned long  MemBase2;          //CS6
unsigned long  *PioVirTop;        //ǥХIOβ۶Ƭɥ쥹
unsigned long  *MemCs1VirTop;     //ǥХCS2۶Ƭɥ쥹
unsigned long  *MemCs2VirTop;     //ǥХCS2۶Ƭɥ쥹
unsigned long  *MemCs6VirTop;     //ǥХCS6۶Ƭɥ쥹
unsigned long  *MemPciLar1VirTop; //PCILAR1ˤƥåȤɥ쥹β۶Ƭɥ쥹
unsigned long  *PhyMemVirTop;     //DMAʪβ۶Ƭɥ쥹
unsigned int   GetIrq;            //ֹ
unsigned long  PhysicalAddr;      //DMAʪƬɥ쥹
unsigned long  PhysicalSize;      //ʪΥ
short          DrvLoadErr;        //ɥ饤еưΥ顼
unsigned char  PciBusNum;         //PCIǥХΥХֹ
unsigned char  PciFuncNum;        //PCIǥХΥե󥯥ֹ
long           InterruptId;       //߼
int            DmaLast;
unsigned long  phyBusAddr;
short          SystemErr;         //ƥ२顼

IOC_MEM_ACC_CMD  MemAccCmd;       //إ꡼ɥ饤Ȥ˻Ȥ̾
unsigned long  ConfigWriteSize;   //ե졼饤ȥ
unsigned char  FpgaCnfData[0x100000]; //FPGAե졼ǡХåե 
int            OpenFlag;

/*** ư *************************************************************/
/****************************************************************************
 [ؿ̾]
   init_module
 [ѥ᡼]
  []
 int 
 [ǽ]
 ɥ饤Ω夬ǽ˵ưؿ
 ǥХΥɥ饤ФϿIOɥ쥹/ꥢɥ쥹¸ȥޥåԥ󥰡
 ʪϢ³γϿ
 ȯ顼ϡХѿꤷƤ
 []
****************************************************************************/
int init_module( void )
{
    unsigned char fNum;
    unsigned char busNum;
    unsigned char funcNum;
    unsigned char irq;
    int           data;
    int           ret;
    int           ofst;
    unsigned long inDat;


    //ǥХե󥯥򥵡
    for( fNum = 0; fNum < 0xFF; fNum++ )
    {
        //ǥХIDѲ뤿ᣲΥǥХIDбʥǥХåǡ
        ret = pcibios_find_device( PRN_VENDOR_ID, PRN_DEVICE_ID_350E,
                                   fNum, &busNum, &funcNum );

//ǥХIDѲΤPCIΥåȤȹͤ롣
//ǥХID350EȤǼʤ롣
#if 0
        //Ĥʤä硢⤦ҤȤĤΥǥХIDå
        if ( ret != PCIBIOS_SUCCESSFUL )
        {
            ret = pcibios_find_device( PRN_VENDOR_ID, PRN_DEVICE_ID_350C,
                                       fNum, &busNum, &funcNum );
        }
#endif

        //PCIǥХĤä
        if ( ret != PCIBIOS_SUCCESSFUL )
        { //ˤ̵
            if ( ret != PCIBIOS_DEVICE_NOT_FOUND )
            {   //顼ɽ
                //printk("PRN_DRV : pcibios_find_device error ret=%x\n", ret);
                SystemErr = SYS_ERR_FIND_DEV_FAILED;
                DrvLoadErr = (short)PRN_FAILED;
            }
        }
        else
        { //Ĥä
            //printk("### PRN_DRV : PCI Board found bus=%x, func=%x ###\n", busNum, funcNum );
           //ư˽빭ѿƤ
            PioBase       = 0;
            MemBase1      = 0;
            MemBase2      = 0;
            PioVirTop     = 0;
            MemCs1VirTop  = 0;
            MemCs2VirTop  = 0;
            MemCs6VirTop  = 0;
            PhyMemVirTop  = 0;
            GetIrq        = 0;
            PhysicalAddr  = 0;
            PhysicalSize  = 0;
            DrvLoadErr    = PRN_SUCCESS;
            PciBusNum     = busNum;
            PciFuncNum    = funcNum;
            SystemErr     = 0;
            OpenFlag      = 0;

            //PCI Configuration쥸
            //DumpPciConfig( busNum, funcNum );

            //ץܡɤIO֥١ɥ쥹
            pcibios_read_config_dword(busNum, funcNum, PCI_BASE_ADDRESS_0, &data);
            PioBase = (data & PCI_BASE_ADDRESS_IO_MASK);
            PioVirTop = ioremap( (unsigned long)PioBase, (unsigned long)0x100);
            //printk("PRN_DRV : PCI_BASE_ADDRESS_0 = %x\n", data);
            //printk("PRN_DRV : IO address = %x\n", (unsigned int)PioBase);

            //ץܡɤCS1֥١ɥ쥹
            pcibios_read_config_dword(busNum, funcNum, PCI_BASE_ADDRESS_1, &data);
            //printk("PRN_DRV : PCI_BASE_ADDRESS_1(CS2) = %x\n", data);
            MemBase1 = data;
            //ʪ֤Ƭ۶֤سƤ
            MemCs1VirTop = ioremap( (unsigned long)MemBase1,(unsigned long)0x00100000 ); //1M
            //printk("PRN_DRV : CS1 Remap addr = %x\n", (int)MemCs1VirTop );
            //printk("PRN_DRV : CS1 access top = %x\n", (int)*MemCs1VirTop );

            //FPGA쥸
            for( ofst = 0; ofst < 11; ofst++ )
            {
                //printk("PRN_DRV : CS1 FPGA Reg(offset %x) = %x\n", ofst*4, (int)*(MemCs1VirTop + ofst ));
            }

            //ץܡɤCS2֥١ɥ쥹
            pcibios_read_config_dword(busNum, funcNum, PCI_BASE_ADDRESS_2, &data);
            //printk("PRN_DRV : PCI_BASE_ADDRESS_2(CS6) = %x\n", data);
            MemBase2 = data;
            //ʪ֤Ƭ۶֤سƤ
            MemCs2VirTop = ioremap( (unsigned long)MemBase2,(unsigned long)0x00100000 ); //1M
            //printk("PRN_DRV : CS2 Remap addr = %x\n", (int)MemCs2VirTop );
            //printk("PRN_DRV : CS2 access top = %x\n", (int)*MemCs2VirTop );

            MemCs6VirTop = MemCs2VirTop;
            MemPciLar1VirTop = MemCs2VirTop;

            //ץܡɤIRQ饤
            pcibios_read_config_byte(busNum, funcNum, PCI_INTERRUPT_LINE, &irq);
            GetIrq = irq;
            //printk("PRN_DRV : GET_IRQ = %x\n", (int)irq );

            //ɥ饤Ф򥭥饯Ͽ
            ret = register_chrdev( PRN_MAJOR, PRN_DRIVER_NAME, &prn_fops );
            if ( ret < 0 )
            {
                //printk("PRN_DRV : Driver register failed ret=%x", ret );
                SystemErr = SYS_ERR_REG_DEV_FAILED;
                DrvLoadErr = (short)PRN_FAILED;
            }

            //IO꥽Ͽ
            ret = (int)request_region( PioBase, 0x100, PRN_DRIVER_NAME );
            if ( ret == 0 )
            {   //Ͽ
                //printk("PRN_DRV : IO request_region failed ret=%x\n", ret);
                DrvLoadErr = (short)PRN_BORAD_MEM_FAILED;
            }

//ꥢ顼ȯ
#ifdef PRN_MEM_ERR_HAPPEN
                DrvLoadErr = (short)PRN_BORAD_MEM_FAILED;
#endif

            //PCILAR1쥸꡼ɤƥפƤ
            inDat = inl( PioBase + 0x10 );
            //printk("PRN_DRV : PCILAR1 = %x\n", (int)inDat );

            //IRQϿ
            ret = request_irq( irq, Prn_interrupt, (SA_INTERRUPT | SA_SHIRQ),
                               PRN_DRIVER_NAME, (void *)PRN_IRQ_MAGIC );
            if ( ret != 0 )
            {
                //printk("PRN_DRV : Driver IRQ request failed ret=%x\n", ret );
                SystemErr = SYS_ERR_REQ_IRQ_FAILED;
                DrvLoadErr = (short)PRN_FAILED;
            }

            //ߤ̵ˤ
            //disable_irq( GetIrq );

            //ʪϢ³ɥ쥹γݡʣͥХȡ
//2MB
#ifdef PRN_PHYSICAL_2M 
            PhysicalSize = 2*1024*1024; //2MByte
//128KB
#else
            PhysicalSize = 128*1024; //128KByte
#endif
            PhysicalAddr = __get_dma_pages(GFP_DMA | GFP_KERNEL, get_order(PhysicalSize));
            if ( PhysicalAddr == 0 )
            {
                //printk("PRN_DRV : Physical memory get error" );
                DrvLoadErr = (short)PRN_PHY_MEM_GET_FAILED;
            }
//ʪ顼ȯ
#ifdef PRN_PHY_ERR_HAPPEN
                DrvLoadErr = (short)PRN_PHY_MEM_GET_FAILED;
#endif

            PhyMemVirTop = (unsigned long *)PhysicalAddr;
            phyBusAddr = virt_to_bus( (unsigned long *)PhysicalAddr );
            //printk("PRN_DRV : PhysicalAddr = %x, phyBusAddr = %x\n",(int)PhysicalAddr, (int)phyBusAddr);

        }
    }

    //printk("PRN_DRV : init_module OUT\n");

    return( (int)PRN_SUCCESS );

}



void cleanup_module(void)
{
    //printk("PRN_DRV : cleanup_module in\n");

    //ʪγ
    if ( PhysicalAddr )
    {
        free_page( PhysicalAddr );
    }

    //IO꥽γ
    if ( PioBase )
    {
        release_region( PioBase, 0x100 );
    }

    if ( MemCs1VirTop )
    {
        iounmap( (void *)MemCs1VirTop );
    }

    if ( MemCs2VirTop )
    {
        iounmap( (void *)MemCs2VirTop );
    }

    //ߤϿ
    if ( GetIrq )
    {
        free_irq( GetIrq, (void *)PRN_IRQ_MAGIC );
    }

    //ǥХϿ
    if (unregister_chrdev(PRN_MAJOR, PRN_DRIVER_NAME) )
    {
        //printk ("PRN_DRV : unregister_chrdev failed\n");
    }
}


/*** ߥӥ *********************************************************/
static void Prn_interrupt(int irq, void *dev_id, struct pt_regs *regs)
{
    int  devSer;
    unsigned int  data;
    unsigned long addr;

    addr = 0;

    //ޤʬγߤɤ򸡺
    devSer = (int)dev_id;
    if ( (devSer & 0xFFFF0) != PRN_IRQ_MAGIC )
    {
        return;
    }

    //PCIߥ쥸BitΩäƤ뤫å
    data = inl( (unsigned long)PioBase );
    if ( (data & (unsigned int)0x00000004) == 0)
    {
        //طʤۤγߤ褿
        return;
    }

    //INTACˣ饤
    *MemCs2VirTop = 0x00000001;

    //NMIȯ쥸饤
    addr = (unsigned long)MemCs1VirTop + 0x4;
    *(unsigned long *)addr = 0;

    //ö߼̤򥳥ޥɤˤƤ
    InterruptId = PRN_INTR_RESPONSE;

//DMA߽λơϡեˤƥꥢΤǲϡ̣⤿ʤ
#if 0
    //߼̤ȽǤХѿ
    //DMA0ߤ
    data = inl( (unsigned long)(PioBase + PRN_PCIDCR0_OFST) );
    if ( ( data & PRN_DMA_COMPLETE) != 0)
    {
        //ߤ򥯥ꥢ
        data = ( data & ~PRN_INTR_DMA_COMPLETE );
        outl( data, (unsigned int)(PioBase + PRN_PCIDCR0_OFST));
        InterruptId = PRN_INTR_DMA_COMPLETE;
    }

    //DMA1ߤ
    data = inl( (unsigned long)(PioBase + PRN_PCIDCR1_OFST) );
    if ( ( data & PRN_DMA_COMPLETE) != 0)
    {
        data = ( data & ~PRN_INTR_DMA_COMPLETE );
        outl( data, (unsigned long)(PioBase + PRN_PCIDCR1_OFST));
        InterruptId = PRN_INTR_DMA_COMPLETE;
    }
#endif

    //PCICRΥӥåȣˤʤޤԵ
    while(1)
    {
        data = inl( (unsigned long)PioBase );
        if ( (data & (unsigned int)0x00000004) == 0)
        {
            break;
        }
    }

    //꡼פʤȥե饰ǧ˼Ԥ뤿ɲ
    udelay(100);

    //ʥȯʤ

}

/*** ץ᥽å ********************************************************/
/****************************************************************************
 [ؿ̾]
   prn_open
 [ѥ᡼]

 []
 int 
 [ǽ]
 ǥХ򥪡ץ󤹤롣ťץ󤷤Ƥ뤫ɤåťץ
 ϥ顼֤ʼºݤˤϣťץDLLǹԤäƤΤǡΥ롼Ȥ̤
 ȤϤʤ
 []
****************************************************************************/
static int prn_open( struct inode *inode, struct file *file )
{

    //printk("PRN_DRV : open method IN\n");

    if( OpenFlag )
    {
        //printk("PRN_DRV : Duplicate open request !");
        return( PRN_DUPLICATE_OPEN );
    }

    OpenFlag = 1;

    //ХѿνԤ
    InterruptId = PRN_INTERUPT_NOT_HAPPENED;
    memset( &MemAccCmd, 0x00, sizeof(MemAccCmd) );

    //ǥХ¤ΤˡΥɥ饤ФΥץ饤١Ȥʥǡ¤ΤΥݥ󥿤
    file->private_data = &PrnInfo;

    //ߤͭˤ
    //enable_irq( GetIrq );

    //printk("PRN_DRV : open method OUT\n");

    //֤
    return( (int)PRN_SUCCESS );
}


/*** ᥽å ********************************************************/
/****************************************************************************
 [ؿ̾]
   prn_close
 [ѥ᡼]
 
 []
 int 
 [ǽ]
 ǥХ򥯥롣ǤΥϤۤȤɰ̣ʤ
 Linuxɥ饤ФϥѰդʤФʤʤΤǡԤ
 衢ŵưǽȤʤäͭʤΤǡɲ򤷤Ƥ
 []

****************************************************************************/
static int prn_close(struct inode *inode, struct file *file)
{

    //printk("PRN_DRV : close method IN\n");

    OpenFlag = 0;

    //printk("PRN_DRV : close method OUT\n");

    //֤
    return( (int)PRN_SUCCESS );
}

/*** ꡼ɥ᥽å **********************************************************/
/****************************************************************************
 [ؿ̾]
   prn_read
 [ѥ᡼]
 
 []
 int 
 [ǽ]
 ǥХǡ꡼ɤ
 ꡼ɤˡϡLibread()ƤӽФˡioctlꤷʤƤϤʤʤ
 ꡼ˡλˤäƤϡץĤΥ꡼ɤơͥ
 ¸桼إԡ礬롣
 []

****************************************************************************/
static int prn_read(struct file *file, char *buf, size_t size, loff_t *offset)
{
    unsigned long *addr;
    //printk("PRN_DRV : read method IN\n");

    //̤ˤäƽʬ
    switch( MemAccCmd.iocId )
    {
        case IOC_RES_READ :
             //printk("PRN_DRV : read type RES_READ\n");

             addr = (unsigned long *)(MemCs2VirTop + 0x80000/sizeof(long));
             //printk("PRN_DRV : read addr = %x, read size = %x\n", (int)addr, (int)size);

            //ǥХΥ꤫ǡ꡼ɤʪ¸
            copy_to_user( buf, (void *)addr, size );

            //INTAC0饤
            *MemCs2VirTop = 0x00000000;
            //A4A4饤(쥹ݥ󥹼եΤ餻)
            udelay(1000);udelay(1000);udelay(1000);udelay(1000);udelay(1000);udelay(1000);
            addr = (unsigned long *)(MemCs2VirTop + 0x80000/sizeof(long));
            *addr = 0x0000A4A4;

            break;

        case IOC_MEM_READ :
             //printk("PRN_DRV : read type MEM_READ\n");

            //ǥХΥ꤫ǡ꡼ɤʪ¸
            copy_to_user( buf, (void *)MemPciLar1VirTop, size );

            break;

        case IOC_MEM_READ_CS1 :
             //printk("PRN_DRV : read type MEM_READ_CS1\n");

            //ǥХΥ꤫ǡ꡼ɤʪ¸
            copy_to_user( buf, (void *)(MemCs1VirTop + (MemAccCmd.addr / 4)), size );

            break;

        case IOC_CP_KERNEL_USR :
             //printk("PRN_DRV : read type CP_KERNEL_USR\n");

            //ʪ꤫桼إǡԡ
            copy_to_user( buf, (void *)PhyMemVirTop, size );
            break;
    }

    //printk("PRN_DRV : read method OUT\n");

    //֤
    return( (int)PRN_SUCCESS );
}


/*** 饤ȥ᥽å **********************************************************/
/****************************************************************************
 [ؿ̾]
   prn_write
 [ѥ᡼]

 []
 int 
 [ǽ]
 ǥХإǡ饤Ȥ
 饤ȤˡϡLibwrite()ƤӽФˡioctlꤷʤƤϤʤʤ
 饤ˡλˤäƤϡͥ¸줿ǡ򡢥ץ
 Υإ饤Ȥ礬롣
 []

****************************************************************************/
static int prn_write(struct file *file, char *buf, size_t size, loff_t *offset)
{
    int  ret = 0;
    unsigned long  *addr;
    int cnt;


    //printk("PRN_DRV : write method IN\n");

    //̤ˤäƽʬ
    switch( MemAccCmd.iocId )
    {
        case IOC_CMD_WRITE :

             //printk("PRN_DRV : write type CMD_WRITE\n");

             //ǥХΥ˥饤
             //桼꤫ʪإԡ
             addr = (unsigned long *)(MemCs2VirTop + 0x20/sizeof(long));
             //printk("PRN_DRV : write addr = %x, read size = %x\n", (int)addr, (int)size);

             copy_from_user( (void *)addr, buf, size );

             //ޥȯԻ˳߼̤֤ˤ
             InterruptId = PRN_INTERUPT_NOT_HAPPENED;

             break;

        case IOC_MEM_WRITE :

             //printk("PRN_DRV : write type MEM_WRITE\n");

             //ǥХΥ˥饤
             //桼꤫ʪإԡ
             //printk("PRN_DRV : write addr = %x, read size = %x\n", (int)MemPciLar1VirTop, (int)size);
             copy_from_user( (void *)MemPciLar1VirTop, buf, size );

             break;

        case IOC_MEM_WRITE_CS1 :

             //printk("PRN_DRV : write type MEM_WRITE_CS1\n");

             //ǥХΥ˥饤
             //桼꤫ʪإԡ
             //printk("PRN_DRV : write addr = %x, read size = %x\n", (int)MemPciLar1VirTop, (int)size);
             copy_from_user( (void *)MemCs1VirTop + MemAccCmd.addr , buf, size );

             break;

        case IOC_CONFIG_WRITE :

             //printk("PRN_DRV : write type CONFIG_WRITE\n");

             //copy User buf -> Kernel buf(used in config write function)
             //ʬǡϤʤȤʤʤ٤ȥơȿȤʤ롣
             //Τᡢʬ䤷ϤƤ
             for (cnt = 0; (4096 * cnt) < size; cnt++ )
             {
                 copy_from_user( (void *)(FpgaCnfData + (4096 * cnt)), buf + (4096 * cnt), 4096 );
             }

             //printk("PRN_DRV : config buf addr = %x, Fgpa.. = %x\n",(int)buf,(int)FpgaCnfData);

             ret = FpgaCnfWtSeq( size );
             //FPGA饤Ƚǥ顼ξϡ¨¤˥顼֤
             if (ret != PRN_SUCCESS)
             {
                 return( PRN_FAILED );
             }
             break;

        case IOC_CP_USR_KERNEL :
             //printk("PRN_DRV : write type CP_USR_KERNEL\n");

             //桼꤫ʪإԡ
             copy_from_user( (void *)PhyMemVirTop, buf, size );
             break;
    }

    //printk("PRN_DRV : write method OUT\n");

    //֤
    return( (int)PRN_SUCCESS );
}


/*** Ʊ᥽å **************************************************/
/****************************************************************************
 [ؿ̾]
   prn_fasync
 [ѥ᡼]
 asyncFlagϡƱIOON/OFF
 []
 int 
 [ǽ]
 ƱΤSIGIOǹԤ̥ץfcntlƥॳƱIO
 ޤϡԤȡδؿ뤵롣
 []

****************************************************************************/
static int prn_fasync(int fd, struct file *file, int asyncFlag)
{
    int  ret;
    PRN_DEV_STR *   dev;

    dev = PrnInfo;

    //ON/OFF
    //printk("PRN_DRV : fasync IN  On/Off = %d\n", asyncFlag);

    //ץ饤١ȹ¤ΤƬɥ쥹
    dev = file->private_data;

    //ƱϿ/
    ret = fasync_helper( fd, file, asyncFlag, &dev->fasync );
    if ( ret < 0 )
    {
        //printk("PRN_DRV : fasync_helper is failed ret = %d\n", ret);
        SystemErr = SYS_ERR_FASYNC_HELP_FAILED;
        return( (int)PRN_FAILED );
    }

    //printk("PRN_DRV : fasync OUT\n");

    //֤
    return( (int)PRN_SUCCESS );
}

/*** IOȥ᥽å **************************************************/
/****************************************************************************
 [ؿ̾]
   prn_ioctl
 [ѥ᡼]

 []
 int 
 [ǽ]
 ǥХؤѥ᡼Ϥñ̿
 IOȥ륳ɤˤäơʬ졢ƽؿ򥳡
 []

****************************************************************************/
static int prn_ioctl(struct inode *inode, struct file *file, 
                        unsigned int ioCmd, unsigned long arg)
{
    short  result; //IOȥؿ

    //printk("PRN_DRV : ioctl IN\n");

    //IOȥ륳ɤˤäƽʬ
    switch(ioCmd)
    {
        case IOC_GET_LOAD_STAT :
            result = Prn_GetLoadStat( arg );
            break;
        case IOC_CLOSE :
            result = Prn_Close( arg );
            break;
        case IOC_RES_READ :
            result = Prn_ResRead( arg );
            break;
        case IOC_CMD_WRITE :
            result = Prn_CmdWrite( arg );
            break;
        case IOC_MEM_READ :
            result = Prn_MemRead( arg );
            break;
        case IOC_MEM_WRITE :
            result = Prn_MemWrite( arg );
            break;
        case IOC_MEM_READ_CS1 :
            result = Prn_MemRead_cs1( arg );
            break;
        case IOC_MEM_WRITE_CS1 :
            result = Prn_MemWrite_cs1( arg );
            break;
        case IOC_DMA_WRITE :
            result = Prn_DmaWrite( arg );
            break;
        case IOC_DMA_READ :
            result = Prn_DmaRead( arg );
            break;
        case IOC_GET_INTER :
            result = Prn_GetInterrupt( arg );
            break;
        case IOC_CP_USR_KERNEL :
            result = Prn_CpUsrToKer( arg );
            break;
        case IOC_CP_KERNEL_USR :
            result = Prn_CpKerToUsr( arg );
            break;
        case IOC_CONFIG_WRITE :
            result = Prn_Config( arg );
            break;
        case IOC_REG_READ :
            result = Prn_RegRead( arg );
            break;
        case IOC_REG_WRITE :
            result = Prn_RegWrite( arg );
            break;
        case IOC_GET_SYS_ERR :
            result = Prn_GetSysErr( arg );
            break;
        case IOC_PCILAR1_SET :
            result = Prn_PciLar1Set( arg );
            break;
        case IOC_GET_VERSION :
            result = Prn_GetVersion( arg );
            break;

        default :
            SystemErr = SYS_ERR_IOCTL_NO_EXIST;
            result = PRN_FAILED;
    }

    //printk("PRN_DRV : ioctl OUT\n");

    return( (int)result );
}

/****************************************************************************
 [ؿ̾]
   PrnGetLoadStat
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ɥ饤Фεư饤֥
 []
 ä̵
****************************************************************************/
static int Prn_GetLoadStat( unsigned long arg )
{
    IOC_GET_LOAD_PARA  iocPara;

    //printk("PRN_DRV : IOC GetLoadStat IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : PrnGetLoadStat verify_area error !");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //桼꤫饫ͥإԡ
    copy_from_user( &iocPara, (void *)arg, sizeof(iocPara) );

    //饤֥ؤǡ
    iocPara.phyAddr  = (unsigned long)PhyMemVirTop;  //ʪƬɥ쥹
    iocPara.phySize  = PhysicalSize;  //ʪΥ
    iocPara.loadSts  = DrvLoadErr;    //ɥ饤еưΥ顼
    iocPara.busAddr  = phyBusAddr;        //ʪΥХɥ쥹DMAžǻѡ

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC GetLoadStat OUT\n");

    return( (int)PRN_SUCCESS );

}


/****************************************************************************
 [ؿ̾]
   PrnClose
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ɥ饤Ф򥯥ɬפʾ
   ߤϡäƤʤ
 []
 ä̵
****************************************************************************/
static int Prn_Close( unsigned long arg )
{
    IOC_CLOSE_PARA  iocPara;

    //printk("PRN_DRV : IOC Close IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : IOC Close verify_area error\n");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC Close OUT\n");

    return( (int)PRN_SUCCESS );
}

/****************************************************************************
 [ؿ̾]
   PrnResRead
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ǥХΥ꤫ʬ꡼ɤ롣
  LibϡΥԤäˡread( )
 []
 ä̵
****************************************************************************/
static int Prn_ResRead( unsigned long arg )
{
    short   result;
    short   dcnt;
    unsigned long  data;
    IOC_RES_READ_PARA  iocPara;

    //printk("PRN_DRV : IOC ResRead IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : IOC ResRead verify_area error\n");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //桼꤫饫ͥإԡ
    copy_from_user( &iocPara, (void *)arg, sizeof(iocPara) );

    //ꥢμ̾
    MemAccCmd.iocId   = IOC_RES_READ;
    MemAccCmd.addr    = iocPara.offset;
    MemAccCmd.size    = iocPara.size;

    result = PRN_SUCCESS;

    //printk("PRN_DRV : IOC ResRead  offset = %x\n", (int)iocPara.offset);

    //CS2ꥢȽ
    if ( (iocPara.offset >= 0x08000000) && ( iocPara.offset <= 0x0BFFFFFF) )
    {
//PCILAR10x08700000ξȤ롣ǤPCILAR1ɬפʤ
//PCILAR10x08700000Ǥ뤫ΥåΤ߹Ԥ
#if 0
        Cs2CmdSet( );
#else
        data = inl(PioBase + 0x10);
        if ( data != 0x08700000 )
        {
            SystemErr = SYS_ERR_PCILAR1_ERR;
            iocPara.result = PRN_FAILED;
            copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
            return( (int)PRN_FAILED );
        }
#endif

        //PCICRBitȽ(ॢȤá
        data = inl(PioBase + 0x00);
        dcnt = 0;
        while(1)
        {
            if ( (data & 0x00000004) == 0 )
            {
                break;
            }
            if ( ++dcnt > 100 )
            {
                result = PRN_FAILED;
                SystemErr = SYS_ERR_RESP_READ_TIMEOUT;
                iocPara.result = PRN_FAILED;
                break;
            }
            udelay((unsigned long)100);
        }
    }

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC ResRead OUT\n");

    return( (int)result );
}

/****************************************************************************
 [ؿ̾]
   PrnCmdWrite
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ǥХΥػʬ饤Ȥ롣
  LibϡΥԤäǡwrite( )
 []
 ä̵
****************************************************************************/
static int Prn_CmdWrite( unsigned long arg )
{
    short   dcnt;
    unsigned long  *cmdPara;
    IOC_CMD_WRITE_PARA  iocPara;
    unsigned long  data;

    //printk("PRN_DRV : IOC CmdWrite IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : IOC CmdWrite verify_area error\n");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //桼꤫饫ͥإԡ
    copy_from_user( &iocPara, (void *)arg, sizeof(iocPara) );

    //ꥢμ̾
    MemAccCmd.iocId   = IOC_CMD_WRITE;
    MemAccCmd.addr    = iocPara.offset;
    MemAccCmd.size    = iocPara.size;

    //饤֥ؤǡ
    iocPara.result = PRN_SUCCESS;

    //printk("PRN_DRV : IOC CmdWrite  Command = 0x%04x offset = 0x%x size = 0x%x\n", (unsigned int)*iocPara.dataPtr, (int)iocPara.offset, (int)iocPara.size);

    //CS2ꥢȽ
    if ( (iocPara.offset >= 0x08000000) && ( iocPara.offset <= 0x0BFFFFFF) )
    {
//PCILAR10x08700000ξȤ롣ǤPCILAR1ɬפʤ
//PCILAR10x08700000Ǥ뤫ΥåΤ߹Ԥ
#if 0
        Cs2CmdSet( );
#else
        data = inl(PioBase + 0x10);
        if ( data != 0x08700000 )
        {
            SystemErr = SYS_ERR_PCILAR1_ERR;
            iocPara.result = PRN_FAILED;
            copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
            return( (int)PRN_FAILED );
        }
#endif
        cmdPara = MemCs2VirTop + (0x20/sizeof(long));

        dcnt = 0;
        while(1)
        {
            if ((*cmdPara & 0x0000FFFF) == 0x0000A4A4)
            {
                break;
            }
            //printk(".");
            if ( ++dcnt > 200 )
            {
                //printk("PRN_DRV : IOC CmdWrite  command area parameter = 0x%x\n", (int)*cmdPara);
                iocPara.result = PRN_CMD_WRITE_TIMEOUT;
                copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
                return( (int)PRN_FAILED );
            }
            udelay((unsigned long)100);
        }
    }

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC CmdWrite OUT\n");

    return( (int)PRN_SUCCESS );
}

/****************************************************************************
 [ؿ̾]
   Prn_MemRead
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ǥХΥ꤫ʬ꡼ɤ롣
  LibϡΥԤäˡread( )
 []
 ä̵
****************************************************************************/
static int Prn_MemRead( unsigned long arg )
{
    IOC_MEM_READ_PARA  iocPara;

    //printk("PRN_DRV : IOC MemRead IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : IOC MemRead verify_area error\n");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //桼꤫饫ͥإԡ
    copy_from_user( &iocPara, (void *)arg, sizeof(iocPara) );

    //ꥢμ̾
    MemAccCmd.iocId   = IOC_MEM_READ;

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC MemRead OUT\n");

    return( (int)PRN_SUCCESS );
}

/****************************************************************************
 [ؿ̾]
   Prn_MemRead_cs1
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ǥХΥ꤫ʬ꡼ɤ롣
  LibϡΥԤäˡread( )
 []
 ä̵
****************************************************************************/
static int Prn_MemRead_cs1( unsigned long arg )
{
    IOC_MEM_READ_PARA  iocPara;

    //printk("PRN_DRV : IOC MemRead cs1 IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : IOC MemRead cs1 verify_area error\n");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //桼꤫饫ͥإԡ
    copy_from_user( &iocPara, (void *)arg, sizeof(iocPara) );

    //ꥢμ̾
    MemAccCmd.iocId   = IOC_MEM_READ_CS1;
    MemAccCmd.addr    = iocPara.offset;

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC MemRead cs1 OUT\n");

    return( (int)PRN_SUCCESS );
}

/****************************************************************************
 [ؿ̾]
   Prn_MemWrite
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ǥХΥػʬ饤Ȥ롣
  LibϡΥԤäǡwrite( )
 []
 ä̵
****************************************************************************/
static int Prn_MemWrite( unsigned long arg )
{
    IOC_MEM_WRITE_PARA  iocPara;

    //printk("PRN_DRV : IOC MemWrite IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : IOC MemWrite verify_area error\n");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //桼꤫饫ͥإԡ
    copy_from_user( &iocPara, (void *)arg, sizeof(iocPara) );

    //ꥢμ̾
    MemAccCmd.iocId   = IOC_MEM_WRITE;

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC MemWrite OUT\n");

    return( (int)PRN_SUCCESS );
}

/****************************************************************************
 [ؿ̾]
   Prn_MemWrite_cs1
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ǥХΥػʬ饤Ȥ롣
  LibϡΥԤäǡwrite( )
 []
 ä̵
****************************************************************************/
static int Prn_MemWrite_cs1( unsigned long arg )
{
    IOC_MEM_WRITE_PARA  iocPara;

    //printk("PRN_DRV : IOC MemWrite cs1 IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : IOC MemWrite cs1 verify_area error\n");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //桼꤫饫ͥإԡ
    copy_from_user( &iocPara, (void *)arg, sizeof(iocPara) );

    //ꥢμ̾
    MemAccCmd.iocId   = IOC_MEM_WRITE_CS1;
    MemAccCmd.addr    = iocPara.offset;

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC MemWrite cs1 OUT\n");

    return( (int)PRN_SUCCESS );
}

/****************************************************************************
 [ؿ̾]
   PrnRegRead
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ǥХΥ꤫4ХȤ꡼ɤ롣
 []
 ä̵
****************************************************************************/
static int Prn_RegRead( unsigned long arg )
{
    IOC_REG_READ_PARA  iocPara;

    //printk("PRN_DRV : IOC RegRead IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : IOC RegRead verify_area error\n");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //桼꤫饫ͥإԡ
    copy_from_user( &iocPara, (void *)arg, sizeof(iocPara) );

    //printk("PRN_DRV : IOC RegRead  offset = 0x%x\n", (int)iocPara.offset);

    //꤫飴ХȤ꡼
    iocPara.rdData = inl(PioBase + iocPara.offset);

    //¹Է̤
    iocPara.result = PRN_SUCCESS;

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC RegRead OUT\n");

    return( (int)PRN_SUCCESS );
}


/****************************************************************************
 [ؿ̾]
   PrnRegWrite
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ǥХΥأХȥ饤Ȥ롣
 []
 ä̵
****************************************************************************/
static int Prn_RegWrite( unsigned long arg )
{
    IOC_REG_WRITE_PARA  iocPara;


    //printk("PRN_DRV : IOC RegWrite IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : IOC RegWrite verify_area error\n");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //桼꤫饫ͥإԡ
    copy_from_user( &iocPara, (void *)arg, sizeof(iocPara) );

    //printk("PRN_DRV : IOC RegWrite  offset = 0x%x write data = 0x%x\n", (int)iocPara.offset, (int)iocPara.wtData);

    //أХȥ饤Ȥ
    outl( iocPara.wtData, (PioBase + iocPara.offset) );

    //¹Է̤
    iocPara.result = PRN_SUCCESS;

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC RegWrite OUT\n");

    return( (int)PRN_SUCCESS );
}


/****************************************************************************
 [ؿ̾]
   PrnDmaWrite
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ɥ饤ʪ꤫ǥХΥDMAž
   饤ȻDMAͥϡѤͤȤʤäƤ
 []
 ä̵
****************************************************************************/
static int Prn_DmaWrite( unsigned long arg )
{
    unsigned int  data;
    unsigned long dpa;
    unsigned long dla;
    unsigned long dtc;
    unsigned long dcr;
    IOC_DMA_WRITE_PARA  iocPara;
    unsigned long chkAddr;

    unsigned long regData;
    unsigned long cnt = 0;

    //printk("PRN_DRV : IOC DmaWrite IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : IOC DmaWrite verify_area error\n");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //桼꤫饫ͥإԡ
    copy_from_user( &iocPara, (void *)arg, sizeof(iocPara) );

    //printk("PRN_DRV : IOC DmaWrite iocPara addr = %x, size = %x, dmaLast = %x\n",
    //                      (int)iocPara.addr, (int)iocPara.size, (int)iocPara.dmaLast );

    //륢ɥ쥹CS2CS3ΤDMAĤ
    if ( ((iocPara.addr < PRN_ADDR_CS2_TOP) || (iocPara.addr > PRN_ADDR_CS2_TAIL))
       && ((iocPara.addr < PRN_ADDR_CS3_TOP) || (iocPara.addr > PRN_ADDR_CS3_TAIL)))
    {
        //printk("PRN_DRV : DMA offset address illegal\n");
        iocPara.result = PRN_ADDR_ILLEGAL;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //žǽϰϳؤžξˤϡ顼Ȥ롣
    chkAddr = iocPara.addr + iocPara.size;
    if ( ((chkAddr < PRN_ADDR_CS2_TOP) || (chkAddr > PRN_ADDR_CS2_TAIL))
       && ((chkAddr < PRN_ADDR_CS3_TOP) || (chkAddr > PRN_ADDR_CS3_TAIL)))
    {
        //printk("PRN_DRV : DMA size illegal\n");
        iocPara.result = PRN_SIZE_ILLEGAL;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //DMAͥ룱
    dpa = PioBase + PRN_PCIDPA1_OFST;
    dla = PioBase + PRN_PCIDLA1_OFST;
    dtc = PioBase + PRN_PCIDTC1_OFST;
    dcr = PioBase + PRN_PCIDCR1_OFST;

    //DMAžΥȤ򤫤
    //PCIɥ쥹
//    outl( PhysicalAddr, dpa );
    outl( phyBusAddr, dpa );
    //륢ɥ쥹
//    outl( 0x08800000, dla );
    outl( iocPara.addr, dla );
    //žХȿ
    outl( iocPara.size, dtc );
    //DMAߵ
    data = inl( dcr );
    data |= PRN_DMA_INTR_ENABLE;
    //DMAž
    data &= ~PRN_DMA_PCI2LOCAL;
    outl( data, dcr );

    //DMA
    data |= PRN_DMA_START;
    outl( data, dcr );

//ե¦ǳȯƤʤ餷ʺΤȤ
#if 0
    //DMAǸ夫
    if ( iocPara.dmaLast == 1 )
    {
        DmaLast = 1;
    }
    else
    {
        DmaLast = 0;
    }
#endif

    while(1)
    {
        udelay(100);

        //DMAžλå(žưӥåȤǥå)
        regData = inl(dcr);
        //ӥåȤˤʤäžλ
        if (!(regData & PRN_DMA_START)){
            //DMAžλ
            break;
        }

        //ॢȥå
        if ( cnt > 500 )
        {
            //printk("### PRN_DRV : DMA Local-PCI Test time out ###\n");
            SystemErr = SYS_ERR_DMA_TIMEOUT;
            iocPara.result = PRN_FAILED;
            copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
            return( (int)PRN_FAILED );
        }
        cnt++;
    }

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC DmaWrite OUT\n");

    return( (int)PRN_SUCCESS );
}


/****************************************************************************
 [ؿ̾]
   PrnDmaRead
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ǥХΥ꤫ɥ饤ʪDMAž
   饤ȻCS2DMAͥϡCS3ϣѤͤȤʤäƤ
 []
 ä̵
****************************************************************************/
static int Prn_DmaRead( unsigned long arg )
{
    unsigned int  data;
    unsigned long dpa;
    unsigned long dla;
    unsigned long dtc;
    unsigned long dcr;
    IOC_DMA_READ_PARA  iocPara;
    unsigned long chkAddr;

    unsigned long regData;
    unsigned long cnt = 0;

    //printk("PRN_DRV : IOC DmaRead IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : PrnDmaRead verify_area error !");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //桼꤫饫ͥإԡ
    copy_from_user( &iocPara, (void *)arg, sizeof(iocPara) );

    //printk("PRN_DRV : IOC DmaRead iocPara addr = %x, size = %x, dmaLast = %x\n",
    //                      (int)iocPara.addr, (int)iocPara.size, (int)iocPara.dmaLast );

    //륢ɥ쥹CS2CS3ΤDMAĤ
    if ( ((iocPara.addr < PRN_ADDR_CS2_TOP) || (iocPara.addr > PRN_ADDR_CS2_TAIL))
       && ((iocPara.addr < PRN_ADDR_CS3_TOP) || (iocPara.addr > PRN_ADDR_CS3_TAIL)))
    {
        //printk("PRN_DRV : DMA offset address illegal\n");
        iocPara.result = PRN_ADDR_ILLEGAL;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //žǽϰϳžξˤϡ顼Ȥ롣
    chkAddr = iocPara.addr + iocPara.size;
    if ( ((chkAddr < PRN_ADDR_CS2_TOP) || (chkAddr > PRN_ADDR_CS2_TAIL))
       && ((chkAddr < PRN_ADDR_CS3_TOP) || (chkAddr > PRN_ADDR_CS3_TAIL)))
    {
        //printk("PRN_DRV : DMA size illegal\n");
        iocPara.result = PRN_SIZE_ILLEGAL;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //DMAͥ룱
    dpa = PioBase + PRN_PCIDPA1_OFST;
    dla = PioBase + PRN_PCIDLA1_OFST;
    dtc = PioBase + PRN_PCIDTC1_OFST;
    dcr = PioBase + PRN_PCIDCR1_OFST;

    //DMAžΥȤ򤫤
    //PCIɥ쥹
    outl( phyBusAddr, dpa );

    //륢ɥ쥹
    outl( iocPara.addr, dla );
    //žХȿ
    outl( iocPara.size, dtc );
    //DMAߵ
    data = inl( dcr );
    data |= PRN_DMA_INTR_ENABLE;
    //DMAž
    data &= ~PRN_DMA_LOCAL2PCI;
    outl( data, dcr );

    //DMA
    data |= PRN_DMA_START;
    outl( data, dcr );

    while(1)
    {
        udelay(100);

        //DMAžλå(žưӥåȤǥå)
        regData = inl(dcr);
        //ӥåȤˤʤäžλ
        if (!(regData & PRN_DMA_START)){
            //DMAžλ
            break;
        }

        //ॢȥå
        if ( cnt > 500 )
        {
            //printk("### PRN_DRV : DMA Local-PCI Test time out ###\n");
            SystemErr = SYS_ERR_DMA_TIMEOUT;
            iocPara.result = PRN_FAILED;
            copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
            return( (int)PRN_FAILED );
        }
        cnt++;
    }

    //饤֥ؤǡ
    iocPara.result = PRN_SUCCESS;

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC DmaRead OUT\n");

    return( (int)PRN_SUCCESS );
}


/****************************************************************************
 [ؿ̾]
   PrnGetInterrupt
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ȯ߼̤
 []
 ä̵
****************************************************************************/
static int Prn_GetInterrupt( unsigned long arg )
{
    IOC_GET_INTER_PARA  iocPara;

    //printk("PRN_DRV : IOC GetInterrupt IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : IOC GetInterrupt verify_area error\n");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //饤֥ؤǡ
    iocPara.interruptId = InterruptId;

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC GetInterrupt OUT\n");

    return( (int)PRN_SUCCESS );
}


/****************************************************************************
 [ؿ̾]
   PrnCpUsrToKer
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 桼֤Υ򥫡֤ͥإԡ
 ñ˥ɥ饤Фʪإ桼֤Υǡ򥳥ԡΤ˻Ѥ
 ǥХΥΰ򥢥ΤǤϤʤ
  LibϡΥԤäǡwrite( )
 []
 ä̵
****************************************************************************/
static int Prn_CpUsrToKer( unsigned long arg )
{
    unsigned long   addr;
    IOC_CP_USR_KERNEL_PARA  iocPara;

    //printk("PRN_DRV : IOC PrnCpUsrToKer IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : IOC PrnCpUsrToKer verify_area error\n");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //ꥢμ̾
    MemAccCmd.iocId = IOC_CP_USR_KERNEL;
    addr = iocPara.phyAddr - PhysicalAddr;
    MemAccCmd.addr  = (unsigned long)PhyMemVirTop + addr;
    MemAccCmd.size  = iocPara.size;

    //饤֥ؤǡ
    iocPara.result = PRN_SUCCESS;

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC PrnCpUsrToKer OUT\n");

    return( (int)PRN_SUCCESS );
}


/****************************************************************************
 [ؿ̾]
   PrnCpKerToUsr
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ֤ͥΥ桼֤إԡ
 ñ˥ɥ饤Фʪ꤫桼֤إǡ򥳥ԡΤ˻Ѥ
 ǥХΥΰ򥢥ΤǤϤʤ
 LibϡΥԤäˡread( )
 []
 ä̵
****************************************************************************/
static int Prn_CpKerToUsr( unsigned long arg )
{
    unsigned long   addr;
    IOC_CP_KERNEL_USR_PARA  iocPara;

    //printk("PRN_DRV : IOC PrnCpKerToUsr IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : IOC PrnCpKerToUsr verify_area error\n");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //ꥢμ̾
    MemAccCmd.iocId = IOC_CP_KERNEL_USR;
    addr = iocPara.phyAddr - PhysicalAddr;
    MemAccCmd.addr  = (unsigned long)PhyMemVirTop + addr;
    MemAccCmd.size  = iocPara.size;

    //饤֥ؤǡ
    iocPara.result = PRN_SUCCESS;

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC PrnCpKerToUsr OUT\n");

    return( (int)PRN_SUCCESS );
}

/****************************************************************************
 [ؿ̾]
   Prn_GetSysErr
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ƥ२顼饤֥֤
 []
 ä̵
****************************************************************************/
static int Prn_GetSysErr( unsigned long arg )
{
    IOC_GET_SYS_ERR_PARA  iocPara;

    //printk("PRN_DRV : IOC GetSysErr IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : PrnGetLoadStat verify_area error !");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //桼꤫饫ͥإԡ
    copy_from_user( &iocPara, (void *)arg, sizeof(iocPara) );

    //饤֥ؤǡ
    iocPara.sysErr  = SystemErr;    //ƥ२顼

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC GetSysErr OUT\n");

    return( (int)PRN_SUCCESS );

}

/****************************************************************************
 [ؿ̾]
   Prn_PciLar1Set
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ƥ२顼饤֥֤
 []
 ä̵
****************************************************************************/
static int Prn_PciLar1Set( unsigned long arg )
{
    short                     ret;
    IOC_PCILAR1_SET_PARA  iocPara;

    //printk("PRN_DRV : IOC PciLar1Set IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : PrnPciLar1Set verify_area error !");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //桼꤫饫ͥإԡ
    copy_from_user( &iocPara, (void *)arg, sizeof(iocPara) );

    //PCILAR1쥸ꥢɥ쥹
    ret = PciLar1Set( iocPara.offset );
    if ( ret != PRN_SUCCESS )
    {
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC PciLar1Set OUT\n");

    return( (int)PRN_SUCCESS );

}

/****************************************************************************
 [ؿ̾]
   Prn_GetVersion
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 ɥ饤ФΥС饤֥֤
 []
 ä̵
****************************************************************************/
static int Prn_GetVersion( unsigned long arg )
{
    IOC_GET_VERSION_PARA  iocPara;

    //printk("PRN_DRV : IOC GetVersion IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : PrnGetVersion error !");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //桼꤫饫ͥإԡ
    copy_from_user( &iocPara, (void *)arg, sizeof(iocPara) );

    //PCILAR1쥸ꥢɥ쥹
    iocPara.drvMajor = DRIVER_MAJOR_VERSION;
    iocPara.drvMinor = DRIVER_MINOR_VERSION;

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC GetVersion OUT\n");

    return( (int)PRN_SUCCESS );

}

/****************************************************************************
 [ؿ̾]
   Prn_Config
 [ѥ᡼]
 unsigned long argIOCѥ᡼
 []
 int 
 [ǽ]
 եǡǥХ˥饤Ȥ
  LibϡΥԤäǡwrite( )
 []
 ä̵
****************************************************************************/
static int Prn_Config( unsigned long arg )
{
    IOC_CONFIG_WRITE_PARA  iocPara;

    //printk("PRN_DRV : IOC PrnConfig IN\n");

    //ѥ᡼å
    if ( verify_area(VERIFY_WRITE, (void *)arg, sizeof(iocPara)) )
    {
        //printk("PRN_DRV : IOC PrnConfig verify_area error\n");
        SystemErr = SYS_ERR_IO_PARA_VERI_ERR;
        iocPara.result = PRN_FAILED;
        copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );
        return( (int)PRN_FAILED );
    }

    //ꥢμ̾
    MemAccCmd.iocId = IOC_CONFIG_WRITE;
//    MemAccCmd.addr  = iocPara.offset;
//    MemAccCmd.size  = iocPara.size;

    //饤֥ؤǡ
    iocPara.result = PRN_SUCCESS;

    //꤫ͥ桼إԡ
    copy_to_user( (void *)arg, &iocPara, sizeof(iocPara) );

    //printk("PRN_DRV : IOC PrnConfig OUT\n");

    return( (int)PRN_SUCCESS );
}

/****************************************************************************
 [ؿ̾]
   PciLar1Set
 [ѥ᡼]

 []
 short 
 [ǽ]
   PCILAR1쥸˻ꤵ줿ɥ쥹򥻥åȤ롣

 []
 PCILAR1쥸ˣ񤭹ޤƤʤ硢ޥɤΥ饤ȡ
   쥹ݥ󥹤Υ꡼ɤԶ礬롣
   ϡɡեװˤPCILAR1쥸ؤΥåȤԤʤꡣ
   ޥɥ饤ȡ쥹ݥ󥹥꡼ɤˤԶ礬ȯˤϡδؿθƤ
   ФPCILAR1쥸ͤåƤߤ뤳ȡ
****************************************************************************/
short  PciLar1Set( unsigned long addr )
{
    volatile unsigned long  pciLcr1Set;
    unsigned long  nmiIntr;
    unsigned long  data;
    int            dcnt;

    //ꥢɥ쥹åCS14CS6Τ줫ϰǤ뤳ȡ

    pciLcr1Set = (unsigned long)MemCs1VirTop + 0x10;
    //PCILAR1쥸ФPCILAR1˥åȤ륢ɥ쥹򥻥å
    *(unsigned long *)pciLcr1Set = addr;

    nmiIntr    = (unsigned long)MemCs1VirTop + 0x04;
    //NMIߤȯ
    *(unsigned long *)nmiIntr = 0;

    dcnt = 0;

    //PCILAR1˻ꥢɥ쥹åȤޤԵ
    while(1)
    {
        data = inl(PioBase + 0x10);
        if ( data == addr )
        {
            break;
        }
        udelay(100);
        if ( ++dcnt > 100 )
        {
            //printk("PRN_DRV : CS2 CMD PCILCR1 set timeout\n");
            SystemErr = SYS_ERR_RESP_READ_TIMEOUT;
            return( (int)PRN_FAILED );
        }
    }

    //printk("PRN_DRV : PCIC PCILAR1 Set reg = %x\n", (int)inl(PioBase + 0x10));

    //PCILAR1쥸ˣ񤭹
    *(unsigned long *)pciLcr1Set = 0x00000000;

    return( (int)PRN_SUCCESS );

}

/****************************************************************************
 [ؿ̾]
 FpgaCnfWtSeq
 [ѥ᡼]
 ʤ
 []
 int   
 [ǽ]
 ǥХΥե졼ꥵʬ饤Ȥ롣
   IOȥǻꤵ줿ʬΥǡ饤Ȥ롣
   顼ϡޤǥȥ饤롣
 []
 ä̵
****************************************************************************/
static int FpgaCnfWtSeq( size_t size )
{
    short          ret;
    int            byteCnt;
    int            bitCnt;
    unsigned char  wkDat;
    unsigned char  wtBit;
    unsigned long  timCnt;
    unsigned long  inDat;
    unsigned long  regData;

    //printk("PRN_DRV : FpgaCnfWtSeq in\n");

    //ե졼׵᤬¦ʤȤOK֤
    //PCILAR1쥸CS6ɥ쥹ɤȽ
    inDat = inl( PioBase + 0x10 );
    if ( inDat != 0x18000000 )
    {
        //CS6ǤʤᡢOKǽλ
        return( PRN_SUCCESS );
    }

    //ALL饤
    *MemCs6VirTop = 0x00000000;

    udelay( (unsigned long)100 );

    //PROGRAMӥåȤ򣰢
    *MemCs6VirTop = PRN_CNF_XPROGRAM;

    //INIT󣰤ˤʤ뤳Ȥǧ
    timCnt = 0;
    while(1)
    {
        if ( ( *MemCs6VirTop & PRN_CNF_XINIT ) == 0 )
        {
            break;
        }
        //INITΥॢͤ10msec
        udelay( (unsigned long)100 );
        if ( ++timCnt > PRN_CNF_INIT_TIMEOUT )
        {
            SystemErr = SYS_ERR_CONF_INIT_NOT_LOW;
            return( (int)PRN_FAILED );
        }
    }

    //PROGRAMӥåȤ򣱢
    *MemCs6VirTop = 0x00000000;
    //INITˤʤޤԤ
    timCnt = 0;
    while(1)
    {
        if ( *MemCs6VirTop & PRN_CNF_XINIT )
        {
            break;
        }
        //INITΥॢͤ10msec
        udelay( (unsigned long)100 );
        if ( ++timCnt > PRN_CNF_INIT_TIMEOUT )
        {
            SystemErr = SYS_ERR_CONF_INIT_NOT_HIGH ;
            return( (int)PRN_FAILED );
        }
    }

    //ѿꤵ줿Хȿʬ֤
    for( byteCnt = 0; byteCnt < size; byteCnt++ )
    { //1ХȤȤ˰ʲԤ
        //ǡμФ
        wkDat = FpgaCnfData[byteCnt];
        //ӥåʬʲ򷫤֤
        for( bitCnt = 0; bitCnt < 8; bitCnt++ )
        {
            //бӥåȰ֤ΥӥåȥǡФ
            //ǽ˥饤ȤӥåȤϺǾ̥ӥåȤȤʤ
            wtBit = ( wkDat & ( (unsigned char)0x80 >> bitCnt ) );
            //ӥåȥǡDIN롣CCLKϣ
            if ( wtBit )
            {
                *MemCs6VirTop = PRN_CNF_DIN;
            }
            else
            {
                *MemCs6VirTop = 0x00000000;
            }
            //ӥåȥǡDIN롣CCLKϣ
            if ( wtBit )
            {
                *MemCs6VirTop = (PRN_CNF_DIN | PRN_CNF_CCLK);
            }
            else
            {
                *MemCs6VirTop = PRN_CNF_CCLK;
            }

//Τᡢν򥫥åȤ⤷ϡ˰٤ΥåˤƤߤ롩
#if 0
            //INITʤХ顼ȯˤʤޤԤɬפʤ
            regData = *MemCs6VirTop;
            if (!(regData & PRN_CNF_XINIT))
            {
                SystemErr = SYS_ERR_CONF_INIT_ILLEGAL_0;
                return( (int)PRN_FAILED );
            }
#endif
        }//End of bitCnt for
//ΤᡢINITΥåХñ̤ˤ롣
#if 1
        //INITʤХ顼ȯˤʤޤԤɬפʤ
        regData = *MemCs6VirTop;
        if (!(regData & PRN_CNF_XINIT))
        {
            SystemErr = SYS_ERR_CONF_INIT_ILLEGAL_0;
            return( (int)PRN_FAILED );
        }
#endif
    }//End of byteCnt for

    //ӥåʬ饤ȤDONEINITå
    //DONE
    timCnt = 0;
    while(1)
    {
        if ( *MemCs6VirTop & PRN_CNF_DONE )
        {
            break;
        }
        //10msecвᤷƤDONEˤʤʤϥ顼
        udelay( (unsigned long)100 );

        if ( ++timCnt > PRN_CNF_DONE_TIMEOUT )
        {
            SystemErr = SYS_ERR_CONF_NOT_DONE;
            return( (int)PRN_FAILED );
        }
    }
    //INIT
    timCnt = 0;
    while(1)
    {
        if ( *MemCs6VirTop & PRN_CNF_XINIT )
        {
            break;
        }
        //10msecвᤷƤINITˤʤʤϥ顼
        udelay( (unsigned long)100 );
        if ( ++timCnt > PRN_CNF_INIT_TIMEOUT )
        {
            SystemErr = SYS_ERR_CONF_INIT_NOT_HIGH ;
            return( (int)PRN_FAILED );
        }
    }
    //¦˥ե졼λΤ뤿ᡢCS2Ƭɥ쥹򥻥åȤNMIȯ
    ret = PciLar1Set( (unsigned long)PRN_CS2_ADDR_TOP );
    if (ret != PRN_SUCCESS)
    {
        return( (int)ret );
    }

    return( (int)PRN_SUCCESS );
}

void DumpPciConfig( unsigned char bus, unsigned char fn )
{
    unsigned int   dwordData;
    unsigned short wordData;
    unsigned char  byteData;

    //printk("\n***************  CONFIGURATION_DATA_START  ***************\n\n");

    //٥ID
    pcibios_read_config_word (bus, fn, 0x00, &wordData);
    //printk("PRN_DRV : VENDOR_ID = %x\n", wordData);

    //ǥХID
    pcibios_read_config_word (bus, fn, 0x02, &wordData);
    //printk("PRN_DRV : DEVICE_ID = %x\n", wordData);

    //ޥɥ쥸
    pcibios_read_config_word (bus, fn, 0x04, &wordData);
    //printk("PRN_DRV : COMMAND_REGISTER = %x\n", wordData);

    //ơ쥸
    pcibios_read_config_word (bus, fn, 0x06, &wordData);
    //printk("PRN_DRV : STATUS_REGISTER = %x\n", wordData);

    //ӥID饹ɤ߹
    pcibios_read_config_dword (bus, fn, 0x08, &dwordData);
    //̣ХȤ򥻥åȡʥӥID
    byteData = (dwordData >> 24);
    //̣ХȤ򥻥åȡʥ饹ɡ
    dwordData = dwordData && 0x00FFFFFF;

    //ӥID
    //printk("PRN_DRV : REVISION_ID = %x\n", byteData);

    //饹
    //printk("PRN_DRV : CLASS_CODE = %x\n", dwordData);

    //å饤
    pcibios_read_config_byte (bus, fn, 0x0C, &byteData);
    //printk("PRN_DRV : CASH_LINE = %x\n", byteData);

    //쥤ƥ󥷥
    pcibios_read_config_byte (bus, fn, 0x0C, &byteData);
    //printk("PRN_DRV : LAYTENSY_TIMER = %x\n", byteData);

    //إå
    pcibios_read_config_byte (bus, fn, 0x0D, &byteData);
    //printk("PRN_DRV : HEADER_TYPE = %x\n", byteData);

    //BIST
    pcibios_read_config_byte (bus, fn, 0x0E, &byteData);
    //printk("PRN_DRV : BIST = %x\n", byteData);

    //١ɥ쥹
    pcibios_read_config_dword (bus, fn, PCI_BASE_ADDRESS_0, &dwordData);
    //printk("PRN_DRV : PCI_BASE_ADDRESS_0 = %x\n", dwordData);

    //١ɥ쥹
    pcibios_read_config_dword (bus, fn, PCI_BASE_ADDRESS_1, &dwordData);
    //printk("PRN_DRV : PCI_BASE_ADDRESS_1 = %x\n", dwordData);

    //١ɥ쥹
    pcibios_read_config_dword (bus, fn, PCI_BASE_ADDRESS_2, &dwordData);
    //printk("PRN_DRV : PCI_BASE_ADDRESS_2 = %x\n", dwordData);

    //١ɥ쥹
    pcibios_read_config_dword (bus, fn, PCI_BASE_ADDRESS_3, &dwordData);
    //printk("PRN_DRV : PCI_BASE_ADDRESS_3 = %x\n", dwordData);

    //١ɥ쥹
    pcibios_read_config_dword (bus, fn, PCI_BASE_ADDRESS_4, &dwordData);
    //printk("PRN_DRV : PCI_BASE_ADDRESS_4 = %x\n", dwordData);

    //١ɥ쥹
    pcibios_read_config_dword (bus, fn, PCI_BASE_ADDRESS_5, &dwordData);
    //printk("PRN_DRV : PCI_BASE_ADDRESS_5 = %x\n", dwordData);

    //CardBus CISݥ
    pcibios_read_config_dword (bus, fn, 0x28, &dwordData);
    //printk("PRN_DRV : CIS_POINTER = %x\n", dwordData);

    //֥ƥ٥ID
    pcibios_read_config_word (bus, fn, 0x2C, &wordData);
    //printk("PRN_DRV : SUB_SYSTEM_VENDOR_ID = %x\n", wordData);

    //֥ƥǥХID
    pcibios_read_config_word (bus, fn, 0x2E, &wordData);
    //printk("PRN_DRV : SUB_SYSTEM_DEVICE_ID = %x\n", wordData);

    //ĥROM١ɥ쥹
    pcibios_read_config_dword (bus, fn, 0x30, &dwordData);
    //printk("PRN_DRV : RESERVE = %x\n", dwordData);

    //ͽ󥨥ꥢ
    pcibios_read_config_dword (bus, fn, 0x34, &dwordData);
    //printk("PRN_DRV : EXT_FUNC_POINTER = %x\n", dwordData);

    //ͽ󥨥ꥢ
    pcibios_read_config_dword (bus, fn, 0x38, &dwordData);
    //printk("PRN_DRV : RESERVE = %x\n", dwordData);

    pcibios_read_config_dword (bus, fn, 0x3C, &dwordData);
    //printk("PRN_DRV : MAX_RET MIN_GRANT INTR_PIN INTR_LINE = %x\n", dwordData);

    //printk("\n***************  CONFIGURATION_DATA_END  ***************\n\n");
}

/***** End of file *****/

